# Interface MatchEngine

All Known Implementing Classes:
  `AbstractCartesianMatchEngine, AbstractSkyMatchEngine, AnisotropicCartesianMatchEngine, CombinedMatchEngine, CuboidCartesianMatchEngine, EllipseCartesianMatchEngine, EllipseCartesianMatchEngine.InDegrees, EllipseSkyMatchEngine, EllipseSkyMatchEngine.InDegrees, EqualsMatchEngine, ErrorCartesianMatchEngine, ErrorSkyMatchEngine, ErrorSkyMatchEngine.InDegrees, FixedSkyMatchEngine, FixedSkyMatchEngine.InDegrees, HumanMatchEngine, IsotropicCartesianMatchEngine, SphericalPolarMatchEngine, SphericalPolarMatchEngine.InDegrees`

public interface MatchEngine
Defines the details of object matching criteria.

This class manages the configuration of matching criteria. Application code can manipulate the `DescribedValue`s provided by this class in accordance with user preferences, and then call the `createMatchKitFactory()` method to supply objects which implement the configured matching functionality itself.

Author:
  Mark Taylor (Starlink)

## Method Summary

Modifier and Type
Method
Description
`Supplier<Coverage>`
`createCoverageFactory()`
Returns a supplier for coverage objects.
`Supplier<MatchKit>`
`createMatchKitFactory()`
Returns a factory for MatchKit instances corresponding to the current settings of this object.
`uk.ac.starlink.table.DescribedValue[]`
`getMatchParameters()`
Returns a set of DescribedValue objects whose values can be modified to modify the matching criteria.
`uk.ac.starlink.table.ValueInfo`
`getMatchScoreInfo()`
Returns a description of the value returned by the `MatchKit.matchScore(Object[], Object[])` method.
`double`
`getScoreScale()`
Returns a scale value for the match score.
`uk.ac.starlink.table.DescribedValue[]`
`getTuningParameters()`
Returns a set of DescribedValue objects whose values can be modified to tune the performance of the match.
`uk.ac.starlink.table.ValueInfo[]`
`getTupleInfos()`
Returns a set of ValueInfo objects indicating what is required for the elements of each tuple.

## Method Details

### createMatchKitFactory

Supplier<MatchKit> createMatchKitFactory()
Returns a factory for MatchKit instances corresponding to the current settings of this object.

The returned value is immutable, and is not affected by subsequent changes of the settings of this object.

Returns:
  match kit supplier

### createCoverageFactory

Supplier<Coverage> createCoverageFactory()
Returns a supplier for coverage objects. Each such coverage can be used to characterise a region of tuple space. When populated with a set of tuples A, any tuple for which the inclusion function defined by its `Coverage.createTestFactory()` method returns false is guaranteed not to match any tuple in A according to this object's match criteria.

The returned value is immutable, and is not affected by subsequent changes of the settings of this object.

If no suitable implementation is available, null may be returned.

Returns:
  supplier of coverage objects, or null

### getMatchScoreInfo

uk.ac.starlink.table.ValueInfo getMatchScoreInfo()
Returns a description of the value returned by the `MatchKit.matchScore(Object[], Object[])` method. The content class should be numeric (though need not be `Double`), and the name, description and units should be descriptive of whatever the physical significance of the value is. If the result of `matchScore` is not interesting (for instance, if it's always either 0 or -1), `null` may be returned.

Returns:
  metadata for the match score results

### getScoreScale

double getScoreScale()
Returns a scale value for the match score. The intention is that the result of `matchScore`/`getScoreScale()` is of order unity, and is thus comparable between different match engines.

As a general rule, the result should be the maximum value ever returned from the `matchScore` method, corresponding to the least good successful match. For binary MatchEngine implementations (all matches are either score=0 or failures) a value of 1 is recommended. If nothing reliable can be said about the scale, NaN may be returned.

Returns:
  scale of successful match scores, a positive finite number or NaN

### getTupleInfos

uk.ac.starlink.table.ValueInfo[] getTupleInfos()
Returns a set of ValueInfo objects indicating what is required for the elements of each tuple. The length of this array is the number of elements in the tuple. Each element should at least have a defined name and content class. The info's `nullable` attribute has a special meaning: if true it means that it makes sense for this element of the tuple to be always blank (for instance assigned to no column).

Returns:
  array of objects describing the requirements on each element of the tuples used for matching

### getMatchParameters

uk.ac.starlink.table.DescribedValue[] getMatchParameters()
Returns a set of DescribedValue objects whose values can be modified to modify the matching criteria. Typically at least one of these will be some sort of tolerance separation which determines how close tuples must be to count as a match. This match engine's behaviour can be modified by calling `DescribedValue.setValue(Object)` on the returned objects.

Returns:
  array of described values which influence the match

### getTuningParameters

uk.ac.starlink.table.DescribedValue[] getTuningParameters()
Returns a set of DescribedValue objects whose values can be modified to tune the performance of the match. This match engine's performance can be influenced by calling `DescribedValue.setValue(Object)` on the returned objects.

Changing these values will make no difference to the output of `MatchKit.matchScore(Object[], Object[])`, but may change the output of `MatchKit.getBins(Object[])`. This may change the CPU and memory requirements of the match, but will not change the result. The default value should be something sensible, so that setting the value of these parameters is not in general required.

Returns:
  array of described values which may influence match performance